VME Intensity Monitor - Feature #13118

Support tracking the chopper's pulse width for PXIE Toroids
07/06/2016 01:23 PM - John Diamond

Status: Closed Start date: 07/06/2016
Priority: Normal Due date:

Assignee: John Diamond % Done: 100%
Category: DAQ Estimated time: 6.00 hours
Target version: Spent time: 24.75 hours
Description

P:L20MOH - pulse width setting device for Greg's chopper front end. Poll this device periodically and adjust the "Integration Window
Size" and "Window Size Multiplier" registers on the Toroid ADC appropriately.

History

#1 - 07/08/2016 01:50 PM - John Diamond
- % Done changed from 0 to 60

Implemented support in the MirrTorDrv class for long integration windows on the ABBOE firmware.
Began implementing the pulse-length monitor loop.

#2 - 07/08/2016 02:43 PM - John Diamond
- % Done changed from 60 to 80

Finished implementing ACNETGateWidthCtl and ACNETGateWidthMonitor classes.

Create two CLI commands for starting the pulse length control monitors:

vmeintGateWidthMonitor acnet_node, ssdn_oid, ssdn_msp, ssdn_misc, acnet_di, rate_str

This command starts monitoring the given ACNET device with a frequency of rate_str. Use D80 to find the relevant SSDN details for the device you
wish to monitor. Note: you may modify the ACNET device details or the monitoring rate by issuing the command again for the same DI
vmeintGateWidthMonitorAdd acnet_di, intensity_device_id

Attaches the intensity device to the list of devices that should have it's integration window track the changes to the pulse legnth ACNET device.

Added the following configuration to pxintstartup to track P:L20MOH for the three PXIE toroids -

# monitors P:L20MOH for pulse length
vmeintGateWidthMonitor 0x0d86, 0x0000, 0x0001, 0x0000, 270599, "1.0"

# Add Toroid devices to gate-width control list for P:L20MOH
vmeintGateWidthMonitorAdd 270599, 0x00
vmeintGateWidthMonitorAdd 270599, 0x01
vmeintGateWidthMonitorAdd 270599, 0x02

No testing done yet. We have Monday afternoon for study time at PXIE.

#3 - 07/11/2016 04:59 PM - John Diamond

- % Done changed from 80 to 90

Spent the afternoon testing and fixing bugs on pxint. It appears now that the correct values are being read from P:L20MOH and the proper integration
window register is being set. We will need to test with small and wide pulse lengths and with beam to verify.

#4 - 07/12/2016 10:45 AM - John Diamond

Would be nice if we could disable the monitor from the command line.
#5 - 07/12/2016 10:47 AM - John Diamond

Not sure why, but | changed the Window Size (which is an output from the digitizer) ACNET device to be the integration window. Reverted this
change and will need to implement a proper ACNET device for controlling the integration window.

#6 - 07/13/2016 04:14 PM - John Diamond
- File 125MHz_Digitizer _Firmware_ver_ABBOF_new_registers.pdf added
- % Done changed from 90 to 80

Turns out that Ning did not upgrade the firmware to ABBOF yet, which is why the gate width register was not being interpreted correctly as 4 bytes.
Ning mentioned that he was concerned that longer gate widths would cause the integrated intensity to exceed 2432 so we came up with a plan to
expand the width of the integrated intensity registers and the MPS thresholds to 40 bits. See the attached firmware changes that Ning has
implemented. The nbeam digitizer has been flashed and is ready for testing.

Today | went through the code and | believe | have all of the parameters and return types expanded from int32_t to int64_t. MPS threshold ACNET
devices will need to be changed from 32-bit int type to float.

Ning has confirmed that the new registers for the upper 8-bits of the integrated intensity (see attached document) will return 0 on the older firmware,
so we should be able to assemble the 40-bit integer without needing to switch on the firmware version.

#7 - 07/14/2016 12:30 PM - John Diamond

Created a command for altering the integration window size from the CLI -

vmeintIntWindowSet dev_id, size_str

Note that the size_str parameter is the window size in microseconds passed inside of a string (use quotes).

#8 - 07/15/2016 10:54 AM - John Diamond
- % Done changed from 80 to 90

Tested the pulse-width monitor on nbeam and it seems to be working.

Tested the MPS thresholds an fixed some bugs in my code that assembles the 40-bit integers. Noticing that the MPS does trip but the board
continues to integrate. Not sure if this is intended or not...

#9 - 07/15/2016 03:01 PM - John Diamond

Further testing revealed a bug in the way the driver was handling the window size multiplier. Fixed with Ning's help.

Once Ning can figure out why tripping on the MPS thresholds does not stop the board from integrating we will be ready to deploy to PXINT.

#10 - 07/18/2016 12:44 PM - John Diamond

Modified the existing ADC window size device code to use intWindowGet(..) and intWindowSet(..) instead of adcWindowSizeGet(..) and
adcWindowSizeSet(..). The former methods use the window size AND get width registers to show/set the window size in microseconds instead of
ADC clock ticks.

Created the following ACNET devices for setting the window size for the PXIE Toroids:

e P:L20TOZ (LEBT Toroid)
¢ P:R50TOZ (MEBT Toroid 1)
e P:M15TOZ (MEBT Toroid 2)

Note that when the pulse width control loop is enabled, the setting device will report the window size but you won't be able to set

#11 - 07/18/2016 04:25 PM - John Diamond
- % Done changed from 90 to 100

This afternoon we deployed the new firmware and these changes to pxint successfully.

Just in case | made a backup of devvmeint.out in the FE boot directory.

The primary transform on the ring pickup MPS threshold devices was changed from 28 (UINT32) to 24 (FLOAT).

First we verified that the MPS thresholds were working properly, then we verified that we could manually set the integration window size properly,
then we verified that we could track changes to P:L20MOH (tried 10us, 20us and 100us). We decided that setting Pulse Length + 25% was best for
now, but we may have to revisit this later.

#12 - 07/18/2016 04:25 PM - John Diamond

- Status changed from Assigned to Closed
